VERSION 5.00
Begin VB.UserControl xlTabCtl 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   900
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5670
   ScaleHeight     =   900
   ScaleWidth      =   5670
   Begin VB.CommandButton cmdScroll 
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton cmdScroll 
      Caption         =   "3"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.PictureBox pbTabs 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1215
      Left            =   480
      ScaleHeight     =   81
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   89
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "xlTabCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' error constants
Private Const TAB_EXISTS = 8601
Private Const TAB_DOESNT_EXIST = 8602

' Constants for API calls
Private Const DT_BOTTOM = &H8
Private Const DT_CALCRECT = &H400
Private Const DT_CENTER = &H1
Private Const DT_NOPREFIX = &H800
Private Const DT_SINGLELINE = &H20
Private Const DT_VCENTER = &H4
Private Const WINDING = 2
Private Const PS_SOLID = 0

' Types for API calls
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

' Type to store information for each tab
Private Type xlTab
    Key As String
    Caption As String
    ToolTipText As String
    Left As Long
    Width As Long
    Active As Boolean
    Corners(0 To 3) As POINTAPI
End Type

' API Declares
Private Declare Function SetBkColor Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal crColor As Long) As Long
    
Private Declare Function SetTextColor Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal crColor As Long) As Long
    
Private Declare Function CreatePen Lib "gdi32" ( _
    ByVal nPenStyle As Long, _
    ByVal nWidth As Long, _
    ByVal crColor As Long) As Long
    
Private Declare Function SelectObject Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal hObject As Long) As Long

Private Declare Function Polygon Lib "gdi32" ( _
    ByVal hDC As Long, _
    lpPoint As POINTAPI, _
    ByVal nCount As Long) As Long
    
Private Declare Function Polyline Lib "gdi32" ( _
    ByVal hDC As Long, _
    lpPoint As POINTAPI, _
    ByVal nCount As Long) As Long
    
Private Declare Function CreateSolidBrush Lib "gdi32" ( _
    ByVal crColor As Long) As Long

Private Declare Function CreatePolygonRgn Lib "gdi32" ( _
    lpPoint As POINTAPI, _
    ByVal nCount As Long, _
    ByVal nPolyFillMode As Long) As Long
    
Private Declare Function FillRgn Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal hRGN As Long, _
    ByVal hBrush As Long) As Long
    
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" ( _
    ByVal hDC As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As RECT, _
    ByVal wFormat As Long) As Long
    
Private Declare Function OleTranslateColor Lib "olepro32.dll" ( _
    ByVal Color As Long, _
    ByVal hPal As Long, _
    ByRef pClrRef As Long) As Long
    
Private Declare Function DeleteObject Lib "gdi32" ( _
    ByVal hObject As Long) As Long
    
Public Event Change(TabKey As String)

' private variables
Private mTabBackColor As OLE_COLOR
Private mTabTextColor As OLE_COLOR
Private mTabLineColor As OLE_COLOR
Private mActiveTabBackColor As OLE_COLOR
Private mActiveTabTextColor As OLE_COLOR
Private mActiveTabLineColor As OLE_COLOR
Private mBackColor As OLE_COLOR
'Private mFlip As Boolean
Private mbNeedButtons As Boolean
Private mLeftMostTab As Long
Private mTabs() As xlTab
Private mTabCount As Long
Private mActiveTab As Long

' exposed properties
Public Property Set Font(NewFont As StdFont)
    Set pbTabs.Font = NewFont
    PropertyChanged "Font"
    UserControl_Resize
    CalcTabPos
    DrawTabs
End Property
Public Property Get Font() As StdFont
    Set Font = pbTabs.Font
End Property

Public Property Let TabBackColor(val As OLE_COLOR)
    mTabBackColor = val
    PropertyChanged "TabBackColor"
    DrawTabs
End Property
Public Property Get TabBackColor() As OLE_COLOR
    TabBackColor = mTabBackColor
End Property

Public Property Let TabTextColor(val As OLE_COLOR)
    mTabTextColor = val
    PropertyChanged "TabTextColor"
    DrawTabs
End Property
Public Property Get TabTextColor() As OLE_COLOR
    TabTextColor = mTabTextColor
End Property

Public Property Let TabLineColor(val As OLE_COLOR)
    mTabLineColor = val
    PropertyChanged "TabLineColor"
    DrawTabs
End Property
Public Property Get TabLineColor() As OLE_COLOR
    TabLineColor = mTabLineColor
End Property

Public Property Let ActiveTabBackColor(val As OLE_COLOR)
    mActiveTabBackColor = val
    PropertyChanged "ActiveTabBackColor"
    DrawTabs
End Property
Public Property Get ActiveTabBackColor() As OLE_COLOR
    ActiveTabBackColor = mActiveTabBackColor
End Property

Public Property Let ActiveTabTextColor(val As OLE_COLOR)
    mActiveTabTextColor = val
    PropertyChanged "ActiveTabTextColor"
    DrawTabs
End Property
Public Property Get ActiveTabTextColor() As OLE_COLOR
    ActiveTabTextColor = mActiveTabTextColor
End Property

Public Property Let ActiveTabLineColor(val As OLE_COLOR)
    mActiveTabLineColor = val
    PropertyChanged "ActiveTabLineColor"
    DrawTabs
End Property
Public Property Get ActiveTabLineColor() As OLE_COLOR
    ActiveTabLineColor = mActiveTabLineColor
End Property

Public Property Let BackColor(val As OLE_COLOR)
    mBackColor = val
    PropertyChanged "BackColor"
    DrawTabs
End Property
Public Property Get BackColor() As OLE_COLOR
    BackColor = mBackColor
End Property

Public Property Let SelectedTab(vData As String)
    Dim i As Long
    Dim r As Long
    r = TabFromKey(vData)
    If r = 0 Then ErrRaise TAB_DOESNT_EXIST
    mActiveTab = r
    For i = 1 To mTabCount
        mTabs(i).Active = (i = r)
    Next
    DrawTabs
    Debug.Print "ChangeTab " & mTabs(r).Key
    RaiseEvent Change(mTabs(r).Key)
End Property

Public Property Get SelectedTab() As String
    
    SelectedTab = mTabs(mActiveTab).Key
    
End Property

Public Property Set MouseIcon(ByVal vData As StdPicture)
    pbTabs.MouseIcon = vData

End Property

Public Property Let MouseIcon(ByVal vData As StdPicture)
    pbTabs.MouseIcon = vData

End Property

Public Property Let MousePointer(ByVal vData As Long)
    'mlngMousePointer = vData
    pbTabs.MousePointer = vData

End Property

'Public Property Let Flip(val As Boolean)
'    mFlip = val
'    PropertyChanged "Flip"
'    UserControl_Resize
'End Property
'Public Property Get Flip() As Boolean
'    Flip = mFlip
'End Property

' exposed methods

Public Sub RemoveTab(Key As String)
' Remove the tab specified by Key
    
    Dim i As Long
    Dim SelTab As Long
    
    ' find the specified tab
    SelTab = TabFromKey(Key)
    If SelTab = 0 Then ErrRaise TAB_DOESNT_EXIST
    
    ' if it's not the last tab then move others down to fill gap
    If SelTab < mTabCount Then
        For i = SelTab To mTabCount - 1
            LSet mTabs(i) = mTabs(i + 1)
        Next
    End If
    
    ' reduce the tab count
    mTabCount = mTabCount - 1
    
    ' if active tab was deleted select a new one
    If SelTab = mActiveTab Then
        If SelTab <= mTabCount Then
            mActiveTab = SelTab
        Else
            mActiveTab = mTabCount
        End If
        If mTabCount > 0 Then
            mTabs(mActiveTab).Active = True
            RaiseEvent Change(mTabs(mActiveTab).Key)
        End If
    End If
    
    ReDim Preserve mTabs(mTabCount)
        
    UserControl_Resize
    DrawTabs

End Sub

Public Sub RemoveAllTabs()
' Remove all tabs

    Erase mTabs()
    mTabCount = 0
    mLeftMostTab = 1
    UserControl_Resize
    DrawTabs
    
End Sub

Public Sub AddTab(Caption As String, _
        Key As String, _
        Optional ToolTip As String = vbNullString, _
        Optional InsertBefore As String = vbNullString)
' Add a new tab.  Specify a tab to insert before by putting
' the Key of the desired tab in InsertBefore, defaults to
' after the last tab

    Dim i As Long
    Dim Pos As Long
    
    ' check for duplicate keys
    If mTabCount > 0 Then
        For i = 1 To mTabCount
            If Key = mTabs(i).Key Then ErrRaise TAB_EXISTS
        Next
    End If
    
    ' find position to put tab
    If (mTabCount > 0) And (InsertBefore <> vbNullString) Then
        ' locate correct tab, and move up
        Pos = TabFromKey(InsertBefore)
        If Pos = 0 Then ErrRaise TAB_DOESNT_EXIST
        mTabCount = mTabCount + 1
        ReDim Preserve mTabs(mTabCount)
        For i = mTabCount - 1 To Pos Step -1
            LSet mTabs(i + 1) = mTabs(i)
        Next
        
        ' move up the active tab if necessary
        If Pos <= mActiveTab Then
            mActiveTab = mActiveTab + 1
        End If
    Else
        ' either no position is specified, or there are no tabs
        ' so insert at the end
        If InsertBefore <> vbNullString Then ErrRaise TAB_DOESNT_EXIST
        Pos = mTabCount + 1
        mTabCount = Pos
        ReDim Preserve mTabs(mTabCount)
    End If
    
    ' and add it
    With mTabs(Pos)
        .Caption = Caption
        .Key = Key
        .ToolTipText = ToolTip
        .Active = False
    End With
    
    ' if this is the first tab, it needs to be active
    If mTabCount = 1 Then
        mActiveTab = 1
        mTabs(Pos).Active = True
        'RaiseEvent Change(mTabs(1).Key)
    End If
    
    UserControl_Resize
    DrawTabs
    
End Sub

' private methods

Private Sub UserControl_InitProperties()
' Init default properties
    On Error Resume Next
    Set Font = UserControl.Parent.Font
    TabBackColor = vbButtonFace
    TabTextColor = vbButtonText
    TabLineColor = vbButtonText
    ActiveTabBackColor = vbWindowBackground
    ActiveTabTextColor = vbButtonText
    ActiveTabLineColor = vbButtonText
    BackColor = vbButtonFace
'    Flip = False
    
    UserControl_Load
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
' Read stored properties
    On Error Resume Next
    Set Font = PropBag.ReadProperty("Font")
    TabBackColor = PropBag.ReadProperty("TabBackColor", vbButtonFace)
    TabTextColor = PropBag.ReadProperty("TabTextColor", vbButtonText)
    TabLineColor = PropBag.ReadProperty("TabLineColor", vbButtonText)
    ActiveTabBackColor = PropBag.ReadProperty("ActiveTabBackColor", vbWindowBackground)
    ActiveTabTextColor = PropBag.ReadProperty("ActiveTabTextColor", vbButtonText)
    ActiveTabLineColor = PropBag.ReadProperty("ActiveTabLineColor", vbButtonText)
    BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
'    Flip = PropBag.ReadProperty("Flip", False)
    
    UserControl_Load
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
' store design time settings
    PropBag.WriteProperty "Font", Font
    PropBag.WriteProperty "TabBackColor", TabBackColor, vbButtonFace
    PropBag.WriteProperty "TabTextColor", TabTextColor, vbButtonText
    PropBag.WriteProperty "TabLineColor", TabLineColor, vbButtonText
    PropBag.WriteProperty "ActiveTabBackColor", ActiveTabBackColor, vbWindowBackground
    PropBag.WriteProperty "ActiveTabTextColor", ActiveTabTextColor, vbButtonText
    PropBag.WriteProperty "ActiveTabLineColor", ActiveTabLineColor, vbButtonText
    PropBag.WriteProperty "BackColor", mBackColor, vbButtonFace
'    PropBag.WriteProperty "Flip", mFlip, False
End Sub

Private Sub UserControl_Load()

    mLeftMostTab = 1
    
    ' have design time view
    If Ambient.UserMode = False Then
        AddTab "Active Tab", "a", vbNullString
        AddTab "InActive Tab", "b", vbNullString
    End If
    
End Sub

Private Sub cmdScroll_Click(Index As Integer)
' scroll the tabs
    
    ' no need to scroll if there are less than 2 tabs
    If mTabCount > 1 Then
    
        If Index = 0 Then
            ' scroll view left
            If mLeftMostTab > 1 Then mLeftMostTab = mLeftMostTab - 1
        Else
            ' scroll view right
            If (mLeftMostTab < mTabCount) And _
                (((mTabs(mTabCount).Left + mTabs(mTabCount).Width) _
                + pbTabs.Left \ Screen.TwipsPerPixelX) > UserControl.Width \ Screen.TwipsPerPixelX) _
                Then mLeftMostTab = mLeftMostTab + 1
        End If
        
        ' redraw tabs
        DrawTabs
    
    End If
    
End Sub

Private Sub cmdScroll_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
' eliminate the focus rectangle on the scroll buttons
    
    UserControl.SetFocus
    
End Sub

Private Sub pbTabs_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
' determine which tab has been selected

    Dim i As Long
    Dim PrevActive As Long
    
    ' bail if there are no tabs
    If mTabCount > 0 Then
    
        ' only respond to left mouse button
        If Button = vbLeftButton Then
            
            ' store previously selected tab
            PrevActive = mActiveTab
        
            ' find the clicked tab
            For i = 1 To mTabCount
                If (X >= mTabs(i).Left) And (X <= mTabs(i).Left + mTabs(i).Width) Then
                    mActiveTab = i
                End If
            Next
            
            ' activate it, setting other to inactive
            For i = 1 To mTabCount
                mTabs(i).Active = (i = mActiveTab)
            Next
            
            ' if active tab is off the left side, then move it back on
            If mActiveTab < mLeftMostTab Then
                mLeftMostTab = mActiveTab
                CalcTabPos
            End If
            
            ' if active tab is off the right side, then move it back on
            If mbNeedButtons Then
                If (mTabs(mActiveTab).Left + mTabs(mActiveTab).Width) * Screen.TwipsPerPixelX _
                        + pbTabs.Left > UserControl.Width Then
                    mLeftMostTab = mLeftMostTab + 1
                    CalcTabPos
                End If
            End If
            
            ' if active tab is different than last then raise the Change event
            'If mActiveTab <> PrevActive Then RaiseEvent Change(mTabs(mActiveTab).Key)
            RaiseEvent Change(mTabs(mActiveTab).Key)
            
        End If
        
        ' redraw the tabs
        DrawTabs
    
    End If
            
End Sub

Private Sub pbTabs_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
' set tooltip based on which tab we are hovering over
    Dim i As Long
    
    If mTabCount > 0 Then
    
        For i = 1 To mTabCount
            If (X > mTabs(i).Left) And (X < mTabs(i).Left + mTabs(i).Width) Then
                pbTabs.ToolTipText = mTabs(i).ToolTipText
            End If
        Next
    
    End If
    
End Sub

Private Sub UserControl_Resize()
    
    CalcTabPos
    
    If mTabCount < 1 Then pbTabs.Width = 1
    
    If UserControl.Width > pbTabs.Width Then
        cmdScroll(0).Visible = False
        cmdScroll(1).Visible = False
        mbNeedButtons = False
        mLeftMostTab = 1
    Else
        If mTabCount > 1 Then
            cmdScroll(0).Visible = True
            cmdScroll(1).Visible = True
            cmdScroll(0).Height = UserControl.Height
            cmdScroll(1).Height = UserControl.Height
            mbNeedButtons = True
        End If
    End If
    
    pbTabs.Height = UserControl.Height
    pbTabs.Top = 0
    
    CalcTabPos
    DrawTabs
    
End Sub

Private Sub CalcTabPos()
' figure size and position of all tabs
    
    Dim i As Long
    Dim X As Long
    
    ' bail if there are no tabs
    If mTabCount <> 0 Then
    
        ' set position of first tab
        mTabs(1).Left = 5
        
        ' get width as position of tabs
        For i = 1 To mTabCount
            CalculateWidth (i)
            If i > 1 Then mTabs(i).Left = (mTabs(i - 1).Width + mTabs(i - 1).Left) + 3
        Next
            
        ' set width of pbTabs
        If mTabCount > 0 Then
            pbTabs.Width = (mTabs(mTabCount).Width + mTabs(mTabCount).Left + 10) * Screen.TwipsPerPixelX
        Else
            pbTabs.Width = 1
        End If
        
        If mLeftMostTab > 0 And mLeftMostTab <= mTabCount Then
            X = mTabs(mLeftMostTab).Left - 4
        End If
        
        ' set position of pbTabs
        If mbNeedButtons Then
            pbTabs.Left = (cmdScroll(0).Width * 2) - (X * Screen.TwipsPerPixelX)
        Else
            pbTabs.Left = X * Screen.TwipsPerPixelX
        End If
    
    End If
    
End Sub

Private Sub DrawTabs()
' draw all the tabs

    Dim i As Long
    Dim Active As Long
    
    ' figure tab positions and sizes
    CalcTabPos
    
    ' draw the line across the top (or bottom) of the entire control
    UserControl.BackColor = mBackColor
    UserControl.ForeColor = mTabLineColor
    UserControl.Cls
    pbTabs.BackColor = mBackColor
    pbTabs.ForeColor = mTabLineColor
    pbTabs.Cls
'    If mFlip Then
'        With UserControl
'            UserControl.Line (0, .ScaleHeight + 1)-(.ScaleWidth, .ScaleHeight + 1)
'        End With
'        With pbTabs
'            pbTabs.Line (0, .ScaleHeight + 1)-(.ScaleWidth, .ScaleHeight + 1)
'        End With
'    Else
        With UserControl
            UserControl.Line (0, 0)-(.ScaleWidth, 0)
        End With
        With pbTabs
            pbTabs.Line (0, 0)-(.ScaleWidth, 0)
        End With
'    End If
    
    ' if there are tabs to draw
    If mTabCount > 0 Then
    
        ' draw the tabs, so that rightmost ones are on top
        For i = mTabCount To 1 Step -1
            If mTabs(i).Active = True Then
                Active = i
            Else
                DrawTab i
            End If
        Next
        
        ' draw the active one last, so that it is always on top
        DrawTab Active
        
    End If
    
    pbTabs.Refresh
    
End Sub

Private Sub DrawTab(TabNum As Long)
' draw an individual tab

    Dim TabColor As Long
    Dim hRGN As Long
    Dim hBRSH As Long
    Dim hOldPen As Long
    Dim hPen As Long
    Dim rct As RECT
    Dim bWasBold As Boolean
    
    CalculateWidth TabNum
    
    ' set up our RECT structure for DrawText
    rct.Left = mTabs(TabNum).Left
    rct.Right = mTabs(TabNum).Left + mTabs(TabNum).Width
    rct.Top = 1
    rct.Bottom = pbTabs.ScaleHeight - 1
    
    ' Set up individual points for trapezoid shaped tabs
'    If mFlip Then
'
'        mTabs(TabNum).Corners(0).x = rct.Left - 5
'        mTabs(TabNum).Corners(0).y = rct.Bottom
'
'        mTabs(TabNum).Corners(1).x = rct.Left + 1
'        mTabs(TabNum).Corners(1).y = rct.Top - 1
'
'        mTabs(TabNum).Corners(2).x = rct.Right - 1
'        mTabs(TabNum).Corners(2).y = rct.Top - 1
'
'        mTabs(TabNum).Corners(3).x = rct.Right + 5
'        mTabs(TabNum).Corners(3).y = rct.Bottom
'
'    Else
        ' top left
        mTabs(TabNum).Corners(0).X = rct.Left - 5
        mTabs(TabNum).Corners(0).Y = rct.Top - 1
        
        ' bottom left
        mTabs(TabNum).Corners(1).X = rct.Left + 1
        mTabs(TabNum).Corners(1).Y = rct.Bottom
        
        ' bottom right
        mTabs(TabNum).Corners(2).X = rct.Right - 1
        mTabs(TabNum).Corners(2).Y = rct.Bottom
        
        ' top right
        mTabs(TabNum).Corners(3).X = rct.Right + 5
        mTabs(TabNum).Corners(3).Y = rct.Top - 1
        
'    End If
    
    ' create a region based on the above points
    hRGN = CreatePolygonRgn(mTabs(TabNum).Corners(0), 4, WINDING)
    
    ' we also need the correct background color
    If mTabs(TabNum).Active Then
        TabColor = ConvertColor(mActiveTabBackColor)
    Else
        TabColor = ConvertColor(mTabBackColor)
    End If
    
    ' create a solid brush using the color from above
    ' this is for the background of the tab
    hBRSH = CreateSolidBrush(TabColor)
    
    ' fill the tab area (region) with the color
    Call FillRgn(pbTabs.hDC, hRGN, hBRSH)
    
    ' draw the lines for the tab
    If mTabs(TabNum).Active Then
        hPen = CreatePen(PS_SOLID, 1, ConvertColor(mActiveTabLineColor))
        hOldPen = SelectObject(pbTabs.hDC, hPen)
        Call Polyline(pbTabs.hDC, mTabs(TabNum).Corners(0), 4)
        Call SelectObject(pbTabs.hDC, hOldPen)
        Call DeleteObject(hPen)
    Else
        hPen = CreatePen(PS_SOLID, 1, ConvertColor(mTabLineColor))
        hOldPen = SelectObject(pbTabs.hDC, hPen)
        Call Polygon(pbTabs.hDC, mTabs(TabNum).Corners(0), 4)
        Call SelectObject(pbTabs.hDC, hOldPen)
        Call DeleteObject(hPen)
    End If
    
    ' if the tab is active, we want a bold font
    If mTabs(TabNum).Active Then
        bWasBold = pbTabs.Font.Bold
        pbTabs.Font.Bold = True
    End If
    
    ' draw the caption
    If mTabs(TabNum).Active Then
        Call SetTextColor(pbTabs.hDC, ConvertColor(mActiveTabTextColor))
    Else
        Call SetTextColor(pbTabs.hDC, ConvertColor(mTabTextColor))
    End If
    
    Call DrawText(pbTabs.hDC, mTabs(TabNum).Caption, Len(mTabs(TabNum).Caption), _
        rct, DT_CENTER Or DT_NOPREFIX Or DT_SINGLELINE Or DT_VCENTER)
        
    ' set font back to what it was
    If mTabs(TabNum).Active Then
        pbTabs.Font.Bold = bWasBold
    End If
    
    ' clean up
    Call DeleteObject(hBRSH)
    Call DeleteObject(hRGN)
    
End Sub

Private Function ConvertColor(OleColor As Long) As Long
' converts from the OLE_COLOR type to COLORREF

    Dim r As Long
    Call OleTranslateColor(OleColor, 0, r)
    ConvertColor = r
    
End Function

Private Sub CalculateWidth(TabNum)
' calculates the width of an individual tab
    Dim rct As RECT
    Dim bWasBold As Boolean
    
    bWasBold = pbTabs.Font.Bold
    
    ' figure the size for a bold font
    pbTabs.Font.Bold = True
    Call DrawText(pbTabs.hDC, mTabs(TabNum).Caption, Len(mTabs(TabNum).Caption), _
        rct, DT_CENTER Or DT_NOPREFIX Or DT_SINGLELINE Or DT_CALCRECT)
        
    ' change the font back
    pbTabs.Font.Bold = bWasBold
    
    ' figure the width
    mTabs(TabNum).Width = rct.Right + 4
    
End Sub

Private Function TabFromKey(Key As String) As Long
' find the index of a tab based on it's key
    
    Dim i As Long
    Dim r As Long
    
    If mTabCount > 0 Then
        For i = 1 To mTabCount
            If mTabs(i).Key = Key Then
                r = i
                Exit For
            End If
        Next
    End If
    
    TabFromKey = r
    
End Function

Private Sub ErrRaise(Num As Long)
' raise appropriate errors with descriptions
    Select Case Num
        Case TAB_EXISTS
            Err.Raise TAB_EXISTS, "xlTabCtl", "Tab with specified key already exists"
        Case TAB_DOESNT_EXIST
            Err.Raise TAB_DOESNT_EXIST, "xlTabCtl", "Tab with specified key does not exist"
    End Select
End Sub
